/* XBBS Library Utility (1.07) for Zoo-archived Text File Libraries */
/* Copyright 1988/89/90 by M. Kimes -- All Rights Reserved */
/* Modified source code or executable may not be distributed */


#include "library.h"

/*-Function declarations------------------------------------------------*/


extern int    pascal list_zoo (word secnum,char printit,char justheader,char *searchfor);
extern void   pascal free_docs(void);
extern void   pascal hitreturn(void);
extern void   pascal cls(void);
extern char   pascal inkey (void);
extern char   pascal carrchk (void);
extern char   pascal fossil (char function, char arg);
extern char   pascal printm (char *text);
extern void   cdecl  deinitialize (void);
extern char * pascal genin (char length,char password,char caps,char hot,char type);
extern char * pascal fidodate (void);
extern long   pascal getxbbstime(void);
extern char   pascal specialkey(char);
extern int    cdecl  break_handler(void);
extern char   pascal readtext(char *);
extern char   pascal printg(char *);
extern char   pascal skip_blanks(FILE *fp);
extern void   pascal chat(void);
extern void   pascal printinfo(void);
extern word   pascal load_sections(void);
extern void   pascal list_sections(void);
extern char * pascal lstrip(char *);
extern void   pascal readfile(word,word);
extern word   pascal security(void);
extern void   pascal full_list(char *keyword);
extern void   pascal quick_list(void);
extern void   pascal printmenu(void);
extern char * pascal rstrip(char *);
extern int    cdecl  printfm(char *,...);
extern char * pascal stristr(char *,char *);
extern void   pascal bios_scroll(int tx, int ty, int bx, int by, int attr, char dir, int howmany);
extern void   pascal status(void);
extern int    pascal common (int func);
extern char * pascal stripcr(char *);
void   pascal maintenance(void);
void   pascal print_maint_menu(void);
int    pascal name_match (char *mask,char *name);
int    pascal trim_section (word secnum,word howmany);
void   pascal clear_stat (void);

/*- Global variables ----------------------------------------*/


#define MAXFILES    4096
#define MAXSECTIONS 1024
#define MAXPTRS     1024

extern char  *section[MAXSECTIONS];
extern char  *document[MAXFILES];
extern word   numsecs;
extern word   numfiles;
extern char   graphics;
extern char   pauser;
extern word   lines;
extern long   timelimit;
extern word   baud;
extern char   numlines;
extern word   seclvl;
extern long   startt;
extern char   commport;
extern union  REGS rg;
extern char   home_dir[128];
extern char   lib_dir[128];
extern char   logfile[133];
extern char   jumped;
extern char   username[36];
extern char   width;
extern char   fast;
extern char   chatting;
extern char   chatted;
extern char   secfile[99];
extern char   quick;
extern char   full;
extern char   grapharea;
extern char   sysmode;
extern char   menus;
extern char   reader[99];
extern char   maint;
extern char   node;
extern word   cursec;
extern char   tmpin[13];
extern char   tmpout[13];
extern char   nowatchdog;
extern char   lastextracted[13];
extern char   maintmenu;
extern char   libmenu;



void pascal maintenance (void) {

    char command;
    char s[10][80];
    char dostring[256];
    char newsect[9];
    char *p;
    int x,y;
    FILE *outfile;
    FILE *infile;
    char nodeid[4];
    struct ffblk f;
    union df fdf;
    union tf ftf;

  while(1) {

    strcpy(newsect,section[cursec]);
    pauser=0;
    printg("\x1b[0;1;34m");
  printfm("\r\n\r\n  Maintenance ** Current: #%u `%s' ** %01u documents",cursec+1,newsect,numfiles);
  if (*section[cursec]=='_') printm("ANSI Graphics are required in this section.\r\n");
    printg("\x1b[0;1;33m");
    if(!menus)print_maint_menu();
    else printm("\r\n[A,B,C,D,E,F,H,J,K,L,M,N,P,Q,R,S,T,U,$,+,!,@,#,%,<>,?]");
  printfm("\r\n  %ld mins: ",(timelimit-getxbbstime())/60L);

    command=*genin(1,0,1,1,ALLL);
  printm("\r\n");
    switch (toupper(command)) {
        case '?':   if(menus) {
                        print_maint_menu();
                        break;
                    }
        case 'H':   if(p=searchpath("LIBSUBOP.HLP")) {
                        readtext(p);
                    }
          else printm("\r\nSorry, no help for maintenance available.\r\n");
                    break;
        case 'B':   if(numsecs==MAXSECTIONS) {
            printm("\r\nNo room for another section.\r\n");
                        break;
                    }
          printm("\r\nFilename for new section (no extension):\r\n -> ");
                    strcpy(newsect,genin(9,0,0,0,FLE));
                    newsect[8]=0;
                    if((p=strchr(newsect,'.'))) *p=0;
                    if(!newsect) break;
                    sprintf(dostring,"ZOO a:I %s < %s > %s",newsect,tmpin,tmpout);
                    goto DoIt1;
        case 'M':   sprintf(dostring,"ZOO a:PMI %s < %s > %s",newsect,tmpin,tmpout);
                    goto DoIt1;
        case 'A':
DoIt:
                    sprintf(dostring,"ZOO a:PI %s < %s > %s",newsect,tmpin,tmpout);

DoIt1:
          printm("\r\nYou may specify up to 9 files to add.");
DoIt2:
                    printm("  [Enter] on a blank line when done.");
                    x=0;
                    while(x<10) {
Over:
            printfm("\r\n%hu: ",x+1);
                        if(command=='P' || command=='C') {
                            strcpy(s[x],genin(75,0,0,0,ALLL));
                            lstrip(s[x]);
                            rstrip(s[x]);
                        }
                        else {
                            if(maint==1 || command=='D' || command=='E')strcpy(s[x],genin(13,0,0,0,FLEW));
                            else strcpy(s[x],genin(75,0,0,0,FLEPW));
                            if(command=='D' || command=='E') {
                                if(atoi(s[x]) && atoi(s[x])<numfiles && atoi(s[x])>0) {
                                    for(y=0;y<strlen(s[x]);y++) printm(BACKSPACE);
                                    strcpy(s[x],document[atoi(s[x])-1]);
                                    printm(s[x]);
                                }
                                else if(*s[x]) {
                                    if(strchr(s[x],'*') || strchr(s[x],'?')) {

                                        word matched=0;

                                        for(y=0;y<numfiles;y++) {
                                            if(name_match(s[x],document[y])) {
                        printfm("\r\nMatches %s",document[y]);
                                                matched++;
                                            }
                                        }
                                        if(!matched) {
                      printfm("\r\n%s doesn't match any files in this section\r\n",s[x]);
                                            continue;
                                        }
                                    }
                                    else {

                                        word matched=0;

                                        for(y=0;y<numfiles;y++) {
                                            if(!stricmp(s[x],document[y])) {
                                                matched++;
                                                break;
                                            }
                                        }
                                        if(!matched) {
                      printfm("\r\n%s isn't a file in this section.\r\n",s[x]);
                                            continue;
                                        }
                                    }
                                }
                            }
                        }
                        if(!*s[x]) break;
                        if(command=='A' || command=='M' || command=='B') {
                            if(findfirst(s[x],&f,0)) {
                printfm("\r\nCan't find %s.\r\n",s[x]);
                                continue;
                            }
                            do {
                printfm("\r\nMatches %s (%ld bytes)",f.ff_name,f.ff_fsize);
                                if(stristr(f.ff_name,".ZOO") || stristr(f.ff_name,".EXE") || stristr(f.ff_name,".COM")) {
                  printfm("\r\nI don't think %s is gonna work...\r\n",s[x]);
                                    goto Over;
                                }
                            } while(!findnext(&f));
                        }
                        x++;
                    }
          printm("\r\n");
                    if(!x || !*s[0]) break;
                    infile=fopen(tmpin,"w");
                    if(!infile) {
            printm("\r\nCouldn't open input file\r\n");
                        break;
                    }
                    for(y=0;y<x;y++) {
                        if(command!='E' && command!='D') {
                            if(command=='A' || command=='M' || command=='B' && (strchr(s[y],'*') || strchr(s[y],'?'))) {
                                if(findfirst(s[y],&f,0)) {
                                    continue;
                                }
                                p=strrchr(s[y],'\\');
                                if(!p) p=strrchr(s[y],':');
                                if(p) {
                                    p++;
                                    *p=0;
                                }       /* s[y] now == path to file */
                                do {
                                    if(stristr(f.ff_name,".ZOO") || stristr(f.ff_name,".EXE") || stristr(f.ff_name,".COM")) {
                                        continue;
                                    }
                  fprintf(infile,"%s%s\r\n",s[y],f.ff_name);
                                } while(!findnext(&f));
                            }
              else fprintf(infile,"%s\r\n",s[y]);
                        }
                        else {
                            strcat(dostring,s[y]);
                            strcat(dostring," ");
                            if(strlen(dostring)>=115) {
                printm("\r\nCommand line overflow; not all files may be affected.\r\n");
                                break;
                            }
                        }
                    }
          if(command=='P' || command=='C') if(stricmp(s[x-1],"\end")) fprintf(infile,"/end\r\n");
                    fclose(infile);
                    if(command=='E' || command=='D') {
                        dostring[114]=0;
                        strcat(dostring," > ");
                        strcat(dostring,tmpout);
                    }
          printfm("\r\n`%s'",dostring);
          printm("\r\n   Do it? (Y/n) ");
                    if(*genin(1,0,1,1,YESNO)=='N') {
                        remove(tmpin);
                        remove(tmpout);
            printm("\r\n");
                        break;
                    }
          printm("\r\nWorking...please wait.\r\n");
                    fossil(WATCHDOG,1);
          clear_stat();
                    system(dostring);
                    fossil(WATCHDOG,0);
                    if(baud)carrchk();
          set_screensize(1);
          validate_cursor();
          status();
                    remove(tmpin);
                    readtext(tmpout);
                    remove(tmpout);
                    sprintf(dostring,"%s.BAK",newsect);
                    remove(dostring);
                    if(command=='B') {
                        sprintf(dostring,"%s.ZOO",newsect);
                        if(!findfirst(dostring,&f,0)) {
                            section[numsecs]=(char *)malloc((word)sizeof(char [13]));
                            if(!section[numsecs]) break;
                            strcpy(section[numsecs],newsect);
                            numsecs++;
                            cursec=numsecs-1;
                            list_zoo(cursec,0,0,NULL);
                        }
                    }
                    if(command=='D' || command=='A' || command=='M') list_zoo(cursec,0,0,NULL);
                    break;
        case 'P':   sprintf(dostring,"ZOO cA %s < %s > %s",newsect,tmpin,tmpout);
                    goto DoIt3;
        case 'C':   if(!quick)quick_list();
          printm("\r\nFile Name or # on which to comment: ");
                    strcpy(s[0],genin(13,0,0,0,FLE));
                    if(!*s[0]) break;
                    if(atoi(s[0]) && atoi(s[0])<numfiles && atoi(s[0])>0) {
                        for(x=0;x<strlen(s[0]);x++) printm(BACKSPACE);
                        strcpy(s[0],document[atoi(s[0])-1]);
                        printm(s[0]);
                    }
          printm("\r\n");
                    sprintf(dostring,"ZOO c %s %s < %s > %s",newsect,s[0],tmpin,tmpout);

DoIt3:
          printm("\r\nYou may enter up to 9 comment lines.");
                    goto DoIt2;
        case 'D':   sprintf(dostring,"ZOO DP %s ",newsect);
                    if(!quick)quick_list();
          printm("\r\nYou may enter up to 9 file names or #'s to delete.\r\n");
                    goto DoIt2;
        case 'E':   sprintf(dostring,"ZOO eOd %s ",newsect);
                    if(!quick)quick_list();
          printm("\r\nYou may enter up to 9 file names or #'s to extract.");
                    goto DoIt2;
    case 'K':   printm("\r\nFilename to remove?\r\n-> ");
                    if(maint==1)strcpy(s[0],genin(13,0,0,0,FLEW));
                    else strcpy(s[0],genin(75,0,0,0,FLEPW));
          printm("\r\n");
                    if(*s[0]) {
                        if(findfirst(s[0],&f,0)) {
              printfm("%s not found.\r\n",s[0]);
                        }
                        else {
                            do {
                printfm("\r\nMatches %s (%lu bytes)",f.ff_name,f.ff_fsize);
                                if(stristr(f.ff_name,".ZOO")) {
                  printm("\r\nUse [R]emove Section instead.\r\n");
                                    goto Avoid;
                                }
                            } while(!findnext(&f));
                        }
                        printm(" Do it? (Y/n) ");
                        if(*genin(1,0,1,1,YESNO)!='N') {
              if(!remove(s[0])) printm("File deleted.\r\n");
              else printm("File not deleted (didn't exist?)\r\n");
                        }
                    }
Avoid:
                    break;
    case 'L':   printm("\r\nArgument for list ([Enter]=all)\r\n-> ");
                    strcpy(s[0],genin(75,0,0,0,FBATCHW));
                    sprintf(dostring,"ZOO VcCd/ %s %s > %s",newsect,s[0],tmpout);
          printfm("\r\n`%s'",dostring);
          printm("\r\nGetting list...\r\n");
                    fossil(WATCHDOG,1);
                    system(dostring);
                    fossil(WATCHDOG,0);
                    if(baud)carrchk();
          set_screensize(1);
          validate_cursor();
          status();
                    readtext(tmpout);
                    remove(tmpout);
                    break;
    case 'R':   printfm("\r\nRemove this section (%s)? (y/N) ",newsect);
                    if(*genin(1,0,1,1,YESNO)!='Y') break;
                    else {
                        sprintf(dostring,"%s.ZOO",newsect);
                        if(!remove(dostring)) {
              printm("\r\nSection removed.\r\n");
                            if(cursec==(numsecs-1)) {
                                free(section[cursec]);
                                cursec--;
                                numsecs--;
                            }
                            else {
                                free(section[cursec]);
                                for(x=cursec;x<(numsecs-1);x++) {
                                    section[x]=section[x+1];
                                }
                            }
                            list_zoo(cursec,0,0,NULL);
                        }
            else printm("\r\nError--not removed.\r\n");
                    }
                    break;
        case 'T':   sprintf(dostring,"ZOO -test %s > %s",newsect,tmpout);
          printfm("\r\n`%s'",dostring);
          printfm("\r\nTesting %s...please wait.\r\n",newsect);
                    fossil(WATCHDOG,1);
                    system(dostring);
                    fossil(WATCHDOG,0);
                    if(baud)carrchk();
                    set_screensize(1);
                    validate_cursor();
                    status();
                    readtext(tmpout);
                    remove(tmpout);
                    break;
        case 'J':   common('J');
                    break;
        case 'N':   common('L');
                    break;
        case 'S':   common('S');
                    break;
    case '$':   printm("\r\nMask: [*.*]\r\n-> ");
                    if(maint<2)p=genin(13,0,0,0,FLEW);
                    else p=genin(74,0,0,0,FLEPW);
                    if(!*p) {
                        p="*.*";
                        printm("*.*");
                    }
          printm("\r\n");
                    if(findfirst(p,&f,0)) {
            printm("\r\nNone matching.\r\n");
                        break;
                    }
                    lines=1;
                    do {
                        fdf.x=f.ff_fdate;
                        ftf.x=f.ff_ftime;
                        pauser=2;
                        printfm("%-13s  %02u/%02u/%02u  %02u:%02u:%02u  %7ld  [",f.ff_name,(fdf.fd.year+80)%100,fdf.fd.month,fdf.fd.day,ftf.ft.hour,ftf.ft.min,ftf.ft.sec,f.ff_fsize);
                        for(x=0;x<8;x++) {
                            y=1;
                            y=y<<x;
                            (f.ff_attrib & y) ? printm("X") : printm ("-");
                        }
                        pauser=1;
            if(printm("]\r\n")) break;
                    } while(!findnext(&f));
                    pauser=0;
                    if (numlines) if (lines>numlines-13) hitreturn();
                    break;
    case '!':   printm("\r\nFile to read:\r\n-> ");
                    if(maint<2)p=genin(13,0,0,0,FLE);
                    else p=genin(76,0,0,0,FLEP);
          printm("\r\n");
                    if(!*p) break;
                    readtext(p);
                    break;
        case '@':   common('R');
                    break;
        case 'U':   if(baud && searchpath("LIBUP.BAT")) {
            printm("\r\nFile to send: ");
                        p=genin(13,0,0,0,FLEW);
            printm("\r\n");
                        if(!*p) break;
                        sprintf(dostring,"%s %s %u %hu",searchpath("LIBUP.BAT"),p,baud,commport);
            printfm("\r\n`%s'\r\n  Do it? (Y/n) ");
                        if(!*genin(1,0,1,1,YESNO)=='N') {
              printm("\r\n");
                            break;
                        }
                        else {
              printm("\r\nEnter SEND mode...\r\n");
              clear_stat();
              system(dostring);
                            if(baud)carrchk();
              set_screensize(1);
              validate_cursor();
              status();
                        }
                        break;
                    }
                    else {
            if(!searchpath("LIBUP.BAT")) printm("\r\nNo upload batch file LIBUP.BAT available.");
            if(!baud) printm("\r\nYou're local; why upload?");
            printm("\r\n");
                    }
                    break;
        case '#':   if(searchpath("LIBEDIT.BAT")) {
            printm("\r\nFile to edit:\r\n-> ");
                        if(maint<2)p=genin(13,0,0,0,FLE);
                        else p=genin(76,0,0,0,FLEP);
            printm("\r\n");
                        if(!*p) break;
                        sprintf(dostring,"LIBEDIT.BAT %s %u %hu",p,baud,commport);
            printfm("`%s'\r\n  Do it? (Y/n) ");
                        if(*genin(1,0,1,1,YESNO)=='N') {
              printm("\r\n");
                            break;
                        }
                        else {
              printm("\r\nLoading editor...\r\n");
              clear_stat();
              system(dostring);
                            if(baud)carrchk();
              set_screensize(1);
              validate_cursor();
              status();
                        }
                        break;
                    }
          else printm("\r\nNo edit batch file LIBEDIT.BAT available.\r\n");
                    break;
    case '%': printfm("\r\n (%u docs) Trim to how many documents? ",numfiles);
                    strcpy(s[0],genin(5,0,0,0,NUM));
          printm("\r\n");
                    x=(word)atol(s[0]);
                    if(numfiles<=x || !x) break;
          printm("\r\nAre you sure? (Y/n) ");
                    if(*genin(1,0,1,1,YESNO)=='N') break;
                    trim_section(cursec,x);
                    quick_list();
                    break;
        case '+':   common('B');
                    break;
        case '*':   printfm("\r\nNew name for section `%s'? ",newsect);
                    strcpy(s[0],genin(9,0,0,0,FLE));
          printm("\r\n");
                    if((p=(strchr(s[0],'.')))) *p=0;
                    if(!*s[0]) break;
          printfm("\r\nRename `%s' to `%s'? (Y/n) ",newsect,s[0]);
                    if(*genin(1,0,1,1,YESNO)!='N') {
                        sprintf(s[1],"%s.ZOO",newsect);
                        sprintf(s[2],"%s.ZOO",s[0]);
            if(rename(s[1],s[2])) printm("\r\nRename failed.");
                        else {
                            strcpy(section[cursec],s[0]);
                        }
                    }
          printm("\r\n");
                    break;
        case '&':   if(maint==1) {
            printm("\r\nSecurity level not high enough.\r\n");
                        break;
                    }
          printm("\r\nEnter ZOO command line.  I'll prepend \'ZOO \' to it.\r\n-> ");
                    p=genin(76,0,0,0,ALLL);
          printm("\r\n");
                    if(!*p) break;
                    sprintf(dostring,"ZOO %s",p);
                    strcat(dostring," > ");
                    strcat(dostring,tmpout);
          printfm("\r\n`%s'",dostring);
          printm("\r\n   Do it? (Y/n) ");
                    if(*genin(1,0,1,1,YESNO)=='N') {
                        remove(tmpout);
            printm("\r\n");
                        break;
                    }
          printm("\r\nWorking...please wait.\r\n");
                    fossil(WATCHDOG,1);
          clear_stat();
          system(dostring);
                    fossil(WATCHDOG,0);
                    if(baud)carrchk();
          set_screensize(1);
          validate_cursor();
          status();
                    readtext(tmpout);
                    remove(tmpout);
                    sprintf(dostring,"%s.BAK",newsect);
                    remove(dostring);
                    list_zoo(cursec,0,0,NULL);
                    break;
        case 'Q':   return;
        default:    if(!common(toupper(command))) {
                        printm("\07");
                        if (menus) {
                            print_maint_menu();
                        }
                        break;
                    }
    }
  }
}



void pascal print_maint_menu (void) {

    if(maintmenu) {
        readtext("LIBMAINT.MNU");
    }
    else {
    printm("\r\n[A]dd documents to section [B]uild a new section   [C]omment on document"
         "\r\n[D]elete documents         [E]xtract documents     [F]ull list toggles"
         "\r\n[J]ump to another section  [K]ill file(s)          [L]ist files"
         "\r\n[M]ove docs into section   [N]umbered list of docs [P]ut in section comment"
         "\r\n[Q]uit Maintenance         [R]emove a section      [S]ection listings"
         "\r\n[T]est section  [&]Zoo Cmd [U]pload file           [$]Directory"
         "\r\n[!]Read file  [+]Find Key  [@]Read document        [#]Edit file"
         "\r\n[%]Trim section to # docs  [*]Rename a section     [H]elp [?]Help/Full Menu");
    }
}



int pascal name_match (char *mask,char *name) { /* Handle wildcards */

    char *m,*n;

    n=name;
    m=mask;

    if(!*mask || !mask) return 1;

    while(*m) {
        if(*m=='?');
        else if (*m=='*') {
            if(strchr(n,'.')) {
                n=strchr(n,'.');
                if(strchr(m,'.')) m=strchr(m,'.');
                else return 0;
            }
            else if(!strchr(m,'.')) return 1;
            else return 0;
        }
        else if(toupper(*m)!=toupper(*n)) return 0;
        m++;
        n++;
    }
    return 1;
}


int pascal trim_section (word secnum,word howmany) {

    register word x;
    char dostring[133]="";

  printm("\r\nTrimming section...please wait.\r\n");
    fossil(WATCHDOG,1);
  clear_stat();
  for(x=0;x<(numfiles-howmany);x++) {
        sprintf(dostring,"%s.BAK",section[secnum]);
        remove(dostring);
        sprintf(dostring,"ZOO D %s %s",section[secnum],document[x]);
    printfm("\r\n`%s'\r\n",dostring);
        system(dostring);
    }
    if(*dostring) {
        sprintf(dostring,"ZOO PE %s",section[secnum]);
    printfm("\r\n`%s'\r\n",dostring);
        system(dostring);
    }
    fossil(WATCHDOG,0);
    if(baud)carrchk();
  set_screensize(1);
  validate_cursor();
  status();
  printm("\r\n");
  list_zoo(secnum,0,0,NULL);
    return 0;
}


void pascal clear_stat (void) {

  cleartoeol(0,realmaxy - 1,realmaxx - 1,7);
}
